FSCK(8)

NAME
fsck - file system consistency check and interactive repair

SYNOPSIS
/etc/fsck [ -l ] [ -d ] -p ] [ -z [ filesystem ... ]
/etc/fsck [ -l ] [ -d ] [ -b block# ] [ -z ] [ -y ] [ -n ] [ filesystem ] ...

DESCRIPTION
The first form of fsck preens a standard set of filesystems or the specified file systems. It is normally used in the script /etc/rc during automatic reboot. In this case fsck reads the table /etc/fstab to determine which file systems to check. It uses the information there to inspect groups of disks in parallel taking maximum advantage of i/o overlap to check the file systems as quickly as possible. Normally, the root file system will be checked on pass 1, other ``root'' (``a'' partition) file systems on pass 2, other small file systems on separate passes (e.g. the ``d'' file systems on pass 3 and the ``e'' file systems on pass 4), and finally the large user file systems on the last pass, e.g. pass 5. Only partitions in fstab with a file system type of ``4.3'', that are mounted ``rw'' or ``rq'' and that have non-zero pass number are checked.

The system takes care that only a restricted class of innocuous inconsistencies can happen unless hardware or software failures intervene. These are limited to the following:

    Unreferenced inodes

    Link counts in inodes too large

    Missing blocks in the free list

    Blocks in the free list also in files

    Counts in the super-block wrong

These are the only inconsistencies that fsck with the -p option will correct; if it encounters other inconsistencies, it exits with an abnormal return status and an automatic reboot will then fail. For each corrected inconsistency one or more lines will be printed identifying the file system on which the correction will take place, and the nature of the correction. After successfully correcting a file system, fsck will print the number of files on that file system, the number of used and free blocks, and the percentage of fragmentation.

If sent a QUIT signal, fsck will finish the file system checks, then exit with an abnormal return status that causes the automatic reboot to fail. This is useful when you wish to finish the file system checks, but do not want the machine to come up multiuser.

Without the -p option, fsck audits and interactively repairs inconsistent conditions for file systems. If the file system is inconsistent the operator is prompted for concurrence before each correction is attempted. It should be noted that some of the corrective actions which are not correctable under the -p option will result in some loss of data. The amount and severity of data lost may be determined from the diagnostic output. The default action for each consistency correction is to wait for the operator to respond yes or no. If the operator does not have write permission on the file system fsck will default to a -n action.

Fsck has more consistency checks than its predecessors check, dcheck, fcheck, and icheck combined.

The following flags are interpreted by fsck.

-b  Use the block specified immediately after the flag as the super block for the file system. Block 32 is always an alternate super block.

-y  Assume a yes response to all questions asked by fsck; this should be used with great caution as this is a free license to continue after essentially unlimited trouble has been encountered.

-n  Assume a no response to all questions asked by fsck; do not open the file system for writing.

-l  Check that the length of a directory is a multiple of 512 bytes.

-z  Recover zero filled holes. Fsck will scan the disc looking for blocks which are all zero. The filesystem does not need to allocate a block for these blocks, so the space used can be recovered. This option will take a long time.

-d  Turn on debug mode. This prints lots of statistics and information.

If no filesystems are given to fsck then a default list of file systems is read from the file /etc/fstab.

Inconsistencies checked are as follows:

1.  Blocks claimed by more than one inode or the free list.

2.  Blocks claimed by an inode or the free list outside the range of the file system.

3.  Incorrect link counts.

4.  Size checks:

    Directory size not of proper format.

5.  Bad inode format.

6.  Blocks not accounted for anywhere.

7.  Directory checks:

    File pointing to unallocated inode.
    Inode number out of range.

8.  Super Block checks:

    More blocks for inodes than there are in the file system.

9.  Bad free block list format.

10. Total free block and/or free inode count incorrect.

Orphaned files and directories (allocated but unreferenced) are, with the operator's concurrence, reconnected by placing them in the lost+found directory. The name assigned is the inode number. If the lost+found directory does not exist, it is created. If there is insufficient space its size is increased.

Checking the raw device is almost always faster.

FILES

/etc/fstab
    contains default list of file systems to check.

DIAGNOSTICS
The diagnostics produced by fsck are fully enumerated and explained in Appendix A of ``Fsck - The UNIX File System Check Program'' (SMM:5).

SEE ALSO
fstab(5), fs(5), newfs(8), mkfs(8), crash(8V), reboot(8)

BUGS
There should be some way to start a fsck -p at pass n.